/*			sio.h


*/
#ifndef	THINK_C
# include	<serial.h>
#else	THINK_C
# include <SerialDvr.h>
#endif THINK_C

#define AIN		"\P.AIN"
#define AOUT	"\P.AOUT"
#define BIN		"\P.BIN"
#define BOUT	"\P.BOUT"
#define	XON		'\021'
#define	XOFF	'\023'

#define DOASYNC

#define BUFFERS	20
#define BUFSIZE	256

struct async_write {
	ParamBlockRec	pb;
	char			buf[BUFSIZE];
};

typedef struct SIOPort {
	int refin, refout;
	unsigned short baud, parity, stopbits, databits;
	SerShk	handshake;
	char * out, * in;
	int insize, outsize;
	char * inbuffer, * outbuffer;
} SIOPort;


extern struct SIOPort PortA, PortB, *Port;

extern SIOInit( /*whichport, speed*/ );
extern SIOSpeed( /*speed*/ );
extern SIOHandshake ( /*fInx, fXOn, fCTS, xOn, xOff*/ );
extern SIOSetting( /*speed, parity, stopbits, databits*/ );
extern SIOInBuffer ( /*buf, size*/ );
extern SIOOutBuffer ( /*buf, size*/ );
extern SIOClose ( /*dtr*/ );
extern SIOPurge ();
extern SIOPutchar ( /*ch*/ );
extern SIOWStr ( /*st*/ );
extern SIOSetFlowCtl ( /*flag*/ );
extern SIOAllowInterrupts ( /*flag*/ );
extern SIOInterrupt ();

/* timeout is in tenths of a second */
extern int SIORead  ( /*byt, maxcount, tenths*/ );

extern int SIOAvail ();

extern putu( /*c, count, refout*/ );
extern int getn ( /*cp, cmax, cmin, refin*/ );

extern SIOWriteBusy (void);


